package cn.lttc.dpworkshopmanageserver.biz.back.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import cn.lttc.dpworkshopmanageserver.biz.back.eneity.Back;
import cn.lttc.dpworkshopmanageserver.biz.back.mapper.BackMapper;
import cn.lttc.dpworkshopmanageserver.biz.back.param.BackParam;
import cn.lttc.dpworkshopmanageserver.biz.back.service.IBackService;
import cn.lttc.dpworkshopmanageserver.biz.filing.entity.Filing;
import cn.lttc.dpworkshopmanageserver.biz.filing.mapper.FilingMapper;
import cn.lttc.dpworkshopmanageserver.core.context.login.LoginContextHolder;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.Date;

/**
 * @author soul
 * @version 1.0.0
 * @title BackServiceImpl
 * @description <TODO description class purpose>
 * @create 2022/11/18 9:05
 **/
@Service
public class BackServiceImpl extends ServiceImpl<BackMapper, Back> implements IBackService{

    @Resource
    private FilingMapper filingMapper;

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(BackParam param) {
        Back back = new Back();
        BeanUtil.copyProperties(param,back);
        back.setBackDate(DateUtil.date(new Date()));
        back.setBackUser(LoginContextHolder.me().getSysLoginUser().getId());
        this.save(back);
        Filing filing = filingMapper.selectById(back.getOrderId());
        Integer stockQty = filing.getStockQty();
        filing.setStockQty(stockQty-param.getBackQty());
        filing.setOrderStatus(2);
        filingMapper.updateById(filing);
    }

    @Override
    public void edit(BackParam param) {
        Back back = this.getById(param.getId());
        BeanUtil.copyProperties(param,back);
        this.updateById(back);
    }
}
