package cn.lttc.dpworkshopmanageserver.biz.filing.controller;

import cn.lttc.dpworkshopmanageserver.biz.filing.param.FilingParam;
import cn.lttc.dpworkshopmanageserver.biz.filing.service.IFilingService;
import cn.lttc.dpworkshopmanageserver.biz.stock.param.StockParam;
import cn.lttc.dpworkshopmanageserver.core.pojo.response.ResponseData;
import cn.lttc.dpworkshopmanageserver.core.pojo.response.SuccessResponseData;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author soul
 * @version 1.0.0
 * @title FilingController
 * @description 建档
 * @create 2022/11/16 13:40
 **/
@RestController
@RequestMapping("/filing")
public class FilingController {

    @Resource
    private IFilingService filingService;
    @PostMapping("/add")
    public ResponseData add(@RequestBody @Validated FilingParam filingParam){
        filingService.add(filingParam);
        return new SuccessResponseData();
    }
    @PostMapping("/edit")
    public ResponseData edit(@RequestBody @Validated FilingParam filingParam){
        filingService.edit(filingParam);
        return new SuccessResponseData();
    }
    @PostMapping("/delete")
    public ResponseData delete(@RequestBody @Validated List<FilingParam> filingParamLst){
        filingService.delete(filingParamLst);
        return new SuccessResponseData();
    }
    @PostMapping("/archive")
    public ResponseData archive(@RequestBody @Validated StockParam stockParam){
        filingService.archive(stockParam);
        return new SuccessResponseData();
    }
//    @GetMapping("/list")
//    public ResponseData list(){
//        return new SuccessResponseData(filingService.getOrderList());
//    }
    @GetMapping("/list/{status}")
    public ResponseData list(@PathVariable("status") Integer status){
        return new SuccessResponseData(filingService.getFilingList(status));
    }
    @GetMapping("/listAvailable")
    public ResponseData listAvailable(){
        return new SuccessResponseData(filingService.listAvailable());
    }
    @GetMapping("/getPlanOrderData")
    public ResponseData getPlanOrderData(){
        return new SuccessResponseData(filingService.getPlanOrderData());
    }
    /**
     * @description:  库存数量（<100）、当前时间-送活交接时间>两天
     * @param: []
     * @return: cn.lttc.dpworkshopmanageserver.core.pojo.response.ResponseData
     * @author Soul
     * @date: 2022/12/2 8:44
     */
    @GetMapping("/getFilterData")
    public ResponseData getFilterData(){
        return new SuccessResponseData(filingService.getFilterData());
    }
}
