package cn.lttc.dpworkshopmanageserver.biz.plan.controller;

import cn.lttc.dpworkshopmanageserver.biz.plan.param.PlanParam;
import cn.lttc.dpworkshopmanageserver.biz.plan.service.IPlanService;
import cn.lttc.dpworkshopmanageserver.core.pojo.response.ResponseData;
import cn.lttc.dpworkshopmanageserver.core.pojo.response.SuccessResponseData;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

/**
 * @author soul
 * @version 1.0.0
 * @title PlanController
 * @description <TODO description class purpose>
 * @create 2022/11/26 13:42
 **/
@RestController
@RequestMapping("/plan")
public class PlanController {
    @Resource
    private IPlanService planService;

    @PostMapping("/add")
    public ResponseData add(@RequestBody @Validated PlanParam planParam){
        planService.add(planParam);
        return new SuccessResponseData();
    }
    @PostMapping("/edit")
    public ResponseData edit(@RequestBody @Validated PlanParam planParam){
        planService.edit(planParam);
        return new SuccessResponseData();
    }
    @PostMapping("/finish")
    public ResponseData finish(@RequestBody @Validated PlanParam planParam){
        planService.finish(planParam);
        return new SuccessResponseData();
    }
    @PostMapping("/delete")
    public ResponseData delete(@RequestBody @Validated PlanParam planParam){
        planService.delete(planParam);
        return new SuccessResponseData();
    }
    @GetMapping("/list/{status}")
    public ResponseData list(@PathVariable("status") Integer status){
//        return new SuccessResponseData(planService.list());
        return new SuccessResponseData(planService.getPlanList(status));
    }
    @GetMapping("plancount")
    public ResponseData queryPlanByOrderNoWorkShift(@RequestParam("orderId") Long orderId, @RequestParam("workShift") String workShift){
        return new SuccessResponseData(planService.queryPlanCount(orderId,workShift));
    }
    /*
    排产统计
     */
    @GetMapping("count")
    public ResponseData count(){
        return new SuccessResponseData(planService.queryPlanCount());
    }
}
