package cn.lttc.dpworkshopmanageserver.biz.plan.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateUtil;
import cn.lttc.dpworkshopmanageserver.biz.plan.dto.CountDto;
import cn.lttc.dpworkshopmanageserver.biz.plan.dto.PlanCountDto;
import cn.lttc.dpworkshopmanageserver.biz.plan.eneity.Plan;
import cn.lttc.dpworkshopmanageserver.biz.plan.mapper.PlanMapper;
import cn.lttc.dpworkshopmanageserver.biz.plan.param.PlanParam;
import cn.lttc.dpworkshopmanageserver.biz.plan.service.IPlanService;
import cn.lttc.dpworkshopmanageserver.core.context.login.LoginContextHolder;
import cn.lttc.dpworkshopmanageserver.core.exception.ServiceException;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @author soul
 * @version 1.0.0
 * @title PlanServiceImpl
 * @description <TODO description class purpose>
 * @create 2022/11/26 13:58
 **/
@Service
public class PlanServiceImpl extends ServiceImpl<PlanMapper, Plan> implements IPlanService {
    @Resource
    private PlanMapper planMapper;
    @Override
    public void add(PlanParam planParam) {
        List<Plan> plans = planMapper.selectList(new QueryWrapper<Plan>().lambda().eq(Plan::getOrderId,
                planParam.getOrderId()).eq(Plan::getWorkShift,planParam.getWorkShift()).apply(true, "TO_DAYS(NOW())-TO_DAYS(create_date) = 0"));
        if (CollectionUtil.isNotEmpty(plans)) {
            throw new ServiceException(500, "该订单该班制今日已排产");
        }
        Plan plan = new Plan();
        BeanUtil.copyProperties(planParam,plan);
        plan.setStatus(false);
        plan.setCreateDate(DateUtil.date(new Date()));
        plan.setCreateUser(LoginContextHolder.me().getSysLoginUser().getId());
        this.save(plan);
    }

    @Override
    public void edit(PlanParam planParam) {
        Plan plan = this.getById(planParam.getId());
        BeanUtil.copyProperties(planParam,plan);
        this.updateById(plan);
    }
    @Override
    public void finish(PlanParam planParam) {
        Plan plan = this.getById(planParam.getId());
        BeanUtil.copyProperties(planParam,plan);
        plan.setStatus(true);
        this.updateById(plan);
    }

    @Override
    public void delete(PlanParam planParam) {
        Long planId = planParam.getId();
        this.removeById(planId);
    }
    @Override
    public List<Plan> getPlanList(Integer status) {
        List<Plan> plans = planMapper.selPlanMapper(status);
        return plans;
    }
    @Override
    public List<PlanCountDto> queryPlanCount(Long orderId, String workShift) {
        List<PlanCountDto> count = planMapper.selPlanCountByOrderNoAndworkShiftMapper(orderId,workShift);
        System.out.println(count);
        return count;
    }
    @Override
    public List<CountDto> queryPlanCount() {
        List<CountDto> plans = planMapper.selectOrderListGroupByCreatedAt();
        System.out.println("--------"+plans);
        List<CountDto> planDtos = new ArrayList<>();
        for(CountDto plan:plans){
            System.out.println(plan.getOrder_id());
            System.out.println("======================"+plan.getFiling().getId());
            plan.setOrder_id(plan.getFiling().getId());
            System.out.println(plan);
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
            String create_at = simpleDateFormat.format(plan.getCreateDate());
            List<Plan> middlePlan = planMapper.selWorkShiftCountByOrderIdAndCreateDate(plan.getOrder_id(),create_at,"中");
            List<Plan> nightPlan = planMapper.selWorkShiftCountByOrderIdAndCreateDate(plan.getOrder_id(),create_at,"晚");
            List<Plan> morningPlan = planMapper.selWorkShiftCountByOrderIdAndCreateDate(plan.getOrder_id(),create_at,"早");
            List<Plan> adminPlan = planMapper.selWorkShiftCountByOrderIdAndCreateDate(plan.getOrder_id(),create_at,"管理线");

            System.out.println("查询数量 "+morningPlan);

//            CountDto CountDto = new CountDto();
            plan.setOrderNo(plan.getOrderNo());
            plan.setOrder_id(plan.getOrder_id());
            if (CollectionUtil.isNotEmpty(middlePlan)){
                plan.setMiddle(middlePlan.get(0).getQty());
            }else{
                plan.setMiddle(0);
            }
//            System.out.println("sdfasdfsdfsafsadf"+morningPlan);
//            System.out.println("sdfasdfsdfsafsadf"+nightPlan.get(0) != null);
//            System.out.println("sdfasdfsdfsafsadf"+nightPlan);
            if (CollectionUtil.isNotEmpty(nightPlan)){
                plan.setNight(nightPlan.get(0).getQty());
            }else{
                plan.setNight(0);
            }
            if (CollectionUtil.isNotEmpty(morningPlan)){
                plan.setMorning(morningPlan.get(0).getQty());
            }else{
                plan.setMorning(0);
            }
            if (CollectionUtil.isNotEmpty(adminPlan)){
                plan.setAdmin(adminPlan.get(0).getQty());
            }else{
                plan.setAdmin(0);
            }

            planDtos.add(plan);

        }

        return planDtos;
    }
}
