package cn.lttc.dpworkshopmanageserver.biz.receive.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import cn.lttc.dpworkshopmanageserver.biz.filing.entity.Filing;
import cn.lttc.dpworkshopmanageserver.biz.filing.mapper.FilingMapper;
import cn.lttc.dpworkshopmanageserver.biz.receive.eneity.Receive;
import cn.lttc.dpworkshopmanageserver.biz.receive.mapper.ReceiveMapper;
import cn.lttc.dpworkshopmanageserver.biz.receive.param.ReceiveParam;
import cn.lttc.dpworkshopmanageserver.biz.receive.service.IReceiveService;
import cn.lttc.dpworkshopmanageserver.core.context.login.LoginContextHolder;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.Date;

/**
 * @author soul
 * @version 1.0.0
 * @title ReceiveServiceImpl
 * @description <TODO description class purpose>
 * @create 2022/11/17 17:27
 **/
@Service
public class ReceiveServiceImpl extends ServiceImpl<ReceiveMapper,Receive> implements IReceiveService {

    @Resource
    private FilingMapper filingMapper;

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(ReceiveParam receiveParam) {
        Receive receive = new Receive();
        receive.setReceiveDate(DateUtil.date(new Date()));
        receive.setReceiveUser(LoginContextHolder.me().getSysLoginUser().getId());
        BeanUtil.copyProperties(receiveParam,receive);
        this.save(receive);
        Long orderId = receive.getOrderId();
        Filing filing = filingMapper.selectById(orderId);
        Integer stockQty = filing.getStockQty();
        filing.setStockQty(stockQty+receiveParam.getReceiveQty());
        filing.setOrderStatus(1);
        filingMapper.updateById(filing);
    }

    @Override
    public void edit(ReceiveParam receiveParam) {
        Receive receive = this.getById(receiveParam.getId());
        BeanUtil.copyProperties(receiveParam,receive);
        this.updateById(receive);
    }
}
