package cn.lttc.dpworkshopmanageserver.biz.report.controller;

import cn.lttc.dpworkshopmanageserver.biz.report.service.IReportService;
import cn.lttc.dpworkshopmanageserver.core.pojo.response.ResponseData;
import cn.lttc.dpworkshopmanageserver.core.pojo.response.SuccessResponseData;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Map;

/**
 * @author soul
 * @version 1.0.0
 * @title ReportController
 * @description <TODO description class purpose>
 * @create 2022/11/23 17:13
 **/
@RestController
@RequestMapping("/report")
public class ReportController {

    @Resource
    private IReportService reportService;

    @GetMapping("/getRcvReport/{daterange}")
    public ResponseData getRcvReport(@PathVariable("daterange") String dateRange){
        return new SuccessResponseData(reportService.getRcvReportData(dateRange));
    }
    @GetMapping("/getRcvReport2/{createdTime}")
    public ResponseData getRcvReport2(@PathVariable("createdTime") String createdTime){
        return new SuccessResponseData(reportService.getRcvReportData2(createdTime));
    }
    @GetMapping("/getBackReport2/{createdTime}")
    public ResponseData getBackReport2(@PathVariable("createdTime") String createdTime){
        return new SuccessResponseData(reportService.getBackReportData2(createdTime));
    }
    @GetMapping("/getRcvReport3")
    public ResponseData getRcvReport3(@RequestParam("filingid") Long filingid,@RequestParam("rcvDate") String rcvDate){
        return new SuccessResponseData(reportService.getRcvReportData3(filingid,rcvDate));
    }
    @GetMapping("/getBackReport3")
    public ResponseData getBackReport3(@RequestParam("filingid") Long filingid,
                                       @RequestParam("backDate") String backDate){
        return new SuccessResponseData(reportService.getBackReportData3(filingid,backDate));
    }
    @GetMapping("/getBackReport/{daterange}")
    public ResponseData getBackReport(@PathVariable("daterange") String dateRange){
        return new SuccessResponseData(reportService.getBackReportData(dateRange));
    }
}
