package cn.lttc.dpworkshopmanageserver.biz.stock.controller;

import cn.lttc.dpworkshopmanageserver.biz.stock.service.IStockService;
import cn.lttc.dpworkshopmanageserver.core.pojo.response.ResponseData;
import cn.lttc.dpworkshopmanageserver.core.pojo.response.SuccessResponseData;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @author soul
 * @version 1.0.0
 * @title StockController
 * @description 库存
 * @create 2022/11/22 9:37
 **/
@RestController
@RequestMapping("/stock")
public class StockController {
    @Resource
    private IStockService stockService;

    @GetMapping("/queryStock")
    public ResponseData queryStock(){
        return new SuccessResponseData(stockService.queryWorkshopStock());
    }
//    @GetMapping("/queryStockByWorkshop/{workshopName}")
//    public ResponseData queryStockByWorkshop(@PathVariable String workshopName){
//        return new SuccessResponseData(stockService.queryTeamStockByWorkshopName(workshopName));
//    }
    @GetMapping("/queryStockByWorkshop/{workshopName}")
    public ResponseData queryStockByWorkshop(@PathVariable Long workshopId){
        return new SuccessResponseData(stockService.queryTeamStockByWorkshopName(workshopId));
    }
}
