package cn.lttc.dpworkshopmanageserver.biz.stock.service.impl;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.lttc.dpworkshopmanageserver.biz.back.eneity.Back;
import cn.lttc.dpworkshopmanageserver.biz.back.mapper.BackMapper;
import cn.lttc.dpworkshopmanageserver.biz.filing.entity.Filing;
import cn.lttc.dpworkshopmanageserver.biz.filing.mapper.FilingMapper;
import cn.lttc.dpworkshopmanageserver.biz.filing.service.impl.FilingServiceImpl;
import cn.lttc.dpworkshopmanageserver.biz.receive.eneity.Receive;
import cn.lttc.dpworkshopmanageserver.biz.receive.mapper.ReceiveMapper;
import cn.lttc.dpworkshopmanageserver.biz.stock.dto.StockReportDto;
import cn.lttc.dpworkshopmanageserver.biz.stock.dto.TeamStockDto;
import cn.lttc.dpworkshopmanageserver.biz.stock.dto.WorkshopStockDto;
import cn.lttc.dpworkshopmanageserver.biz.stock.service.IStockService;
import cn.lttc.dpworkshopmanageserver.biz.team.entity.Team;
import cn.lttc.dpworkshopmanageserver.biz.team.mapper.TeamMapper;
import cn.lttc.dpworkshopmanageserver.biz.workshop.entity.Workshop;
import cn.lttc.dpworkshopmanageserver.biz.workshop.mapper.WorkshopMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author soul
 * @version 1.0.0
 * @title StockServiceImpl
 * @description <TODO description class purpose>
 * @create 2022/11/22 10:28
 **/
@Service
public class StockServiceImpl implements IStockService {

    @Resource
    private FilingMapper filingMapper;
    @Resource
    private ReceiveMapper receiveMapper;
    @Resource
    private BackMapper backMapper;
    @Resource
    private WorkshopMapper workshopMapper;
    @Resource
    private TeamMapper teamMapper;
    //原方法
//    @Override
//    public StockReportDto queryWorkshopStock() {
//        Integer factoryTotalQty =
//                filingMapper.selectList(new QueryWrapper<Filing>().lambda().eq(Filing::getStatus,false
//        ).select(Filing::getStockQty)).stream().mapToInt(Filing::getStockQty).sum();
//        StockReportDto stockReportDto = new StockReportDto();
//        stockReportDto.setFactoryName("DP工厂");
//        stockReportDto.setFactoryTotalQty(factoryTotalQty);
//        List<WorkshopStockDto> workshopStockDtos = new ArrayList<>();
//        Map<String, Integer> collects = filingMapper.selectList(new QueryWrapper<Filing>().lambda().eq(Filing::getStatus,false
//                ).select(Filing::getZyProductWorkshop, Filing::getStockQty))
//                .stream().collect(Collectors.groupingBy(Filing::getZyProductWorkshop, Collectors.summingInt(Filing::getStockQty)));
//        if(CollectionUtil.isEmpty(collects)){
//            return stockReportDto;
//        }else {
//            collects.forEach((workshopName,qty)->{
//                WorkshopStockDto workshopStockDto = new WorkshopStockDto();
//                workshopStockDto.setWorkshopName(workshopName);
//                workshopStockDto.setWorkshopQty(qty);
//                workshopStockDto.setTeamStocks(new ArrayList<>());
//                workshopStockDtos.add(workshopStockDto);
//                List<TeamStockDto> teamStockDtos = this.queryTeamStockByWorkshopName(workshopName);
//                workshopStockDto.setTeamStocks(teamStockDtos);
//            });
//            stockReportDto.setProductWorkshops(workshopStockDtos);
//        }
//        return stockReportDto;
//    }

    @Override
    public StockReportDto queryWorkshopStock() {
        Integer factoryTotalQty =
                filingMapper.selectList(new QueryWrapper<Filing>().lambda().eq(Filing::getStatus,false
                ).ne(Filing::getOrderStatus,3).select(Filing::getStockQty)).stream().mapToInt(Filing::getStockQty).sum();
        StockReportDto stockReportDto = new StockReportDto();
        stockReportDto.setFactoryName("DP工厂");
        stockReportDto.setFactoryTotalQty(factoryTotalQty);
        List<WorkshopStockDto> workshopStockDtos = new ArrayList<>();
//        Map<String, Integer> collects = filingMapper.selectList(new QueryWrapper<Filing>().lambda().eq(Filing::getStatus,false
//                ).select(Filing::getZyProductWorkshop, Filing::getStockQty))
//                .stream().collect(Collectors.groupingBy(Filing::getZyProductWorkshop, Collectors.summingInt(Filing::getStockQty)));
        Map<Long, Integer> collects = filingMapper.selectList(new QueryWrapper<Filing>().lambda().eq(Filing::getStatus,
                        false
                ).ne(Filing::getOrderStatus,3).select(Filing::getWorkshopId, Filing::getStockQty))
                .stream().collect(Collectors.groupingBy(Filing::getWorkshopId, Collectors.summingInt(Filing::getStockQty)));
        if(CollectionUtil.isEmpty(collects)){
            return stockReportDto;
        }else {
//            collects.forEach((workshopName,qty)->{
//                WorkshopStockDto workshopStockDto = new WorkshopStockDto();
//                workshopStockDto.setWorkshopName(workshopName);
//                workshopStockDto.setWorkshopQty(qty);
//                workshopStockDto.setTeamStocks(new ArrayList<>());
//                workshopStockDtos.add(workshopStockDto);
//                List<TeamStockDto> teamStockDtos = this.queryTeamStockByWorkshopName(workshopName);
//                workshopStockDto.setTeamStocks(teamStockDtos);
            collects.forEach((workshopId,qty)->{
                WorkshopStockDto workshopStockDto = new WorkshopStockDto();
                Workshop workshop = workshopMapper.selectById(workshopId);
                workshopStockDto.setWorkshopName(workshop.getZyProductWorkshop());
                workshopStockDto.setWorkshopQty(qty);
                workshopStockDto.setTeamStocks(new ArrayList<>());
                workshopStockDtos.add(workshopStockDto);
                List<TeamStockDto> teamStockDtos = this.queryTeamStockByWorkshopName(workshopId);
                workshopStockDto.setTeamStocks(teamStockDtos);
            });
            stockReportDto.setProductWorkshops(workshopStockDtos);
        }
        return stockReportDto;
    }
    @Override
    public List<TeamStockDto> queryTeamStockByWorkshopName(Long workshopId) {
        List<TeamStockDto> teamStockDtos = new ArrayList<>();
        List<Filing> filings =
                filingMapper.selectList(new QueryWrapper<Filing>().lambda().eq(Filing::getWorkshopId, workshopId).eq(Filing::getStatus,false
                ).ne(Filing::getOrderStatus,3).select(Filing::getId, Filing::getTeamId, Filing::getOrderNo));
        if(CollectionUtil.isEmpty(filings)){
            return teamStockDtos;
        }else {
            List<Long> filingIds = filings.stream().map(Filing::getId).collect(Collectors.toList());
            Map<Long, Integer> receiveQtyMap = receiveMapper.selectList(new QueryWrapper<Receive>().lambda().in(Receive::getOrderId, filingIds)
                    .select(Receive::getOrderId, Receive::getReceiveQty)).stream().collect(Collectors.groupingBy(Receive::getOrderId, Collectors.summingInt(Receive::getReceiveQty)));
            Map<Long, Integer> backQtyMap = backMapper.selectList(new QueryWrapper<Back>().lambda().in(Back::getOrderId, filingIds)
                    .select(Back::getOrderId, Back::getBackQty)).stream().collect(Collectors.groupingBy(Back::getOrderId, Collectors.summingInt(Back::getBackQty)));
            filings.forEach(item->{
                Long filingId = item.getId();
                String orderNo = item.getOrderNo();
                Long teamId = item.getTeamId();
                Team team = teamMapper.selectById(teamId);
                Integer rcvQty = ObjectUtil.isNull(receiveQtyMap.get(filingId))?0:receiveQtyMap.get(filingId);
                Integer backQty = ObjectUtil.isNull(backQtyMap.get(filingId))?0:backQtyMap.get(filingId);
                TeamStockDto teamStockDto = new TeamStockDto();
                teamStockDto.setTeamName(team.getZyTeam());
                teamStockDto.setOrderNo(orderNo);
                teamStockDto.setTotalRcvQty(rcvQty);
                teamStockDto.setTotalBackQty(backQty);
                teamStockDto.setTeamTotalQty(rcvQty-backQty);
                teamStockDtos.add(teamStockDto);
            });
        }
        return teamStockDtos;
    }

//    @Override
//    public List<TeamStockDto> queryTeamStockByWorkshopName(String workshopName) {
//        List<TeamStockDto> teamStockDtos = new ArrayList<>();
//        List<Filing> filings =
//                filingMapper.selectList(new QueryWrapper<Filing>().lambda().eq(Filing::getZyProductWorkshop, workshopName).eq(Filing::getStatus,false
//                ).select(Filing::getId, Filing::getZyTeam, Filing::getOrderNo));
//        if(CollectionUtil.isEmpty(filings)){
//            return teamStockDtos;
//        }else {
//            List<Long> filingIds = filings.stream().map(Filing::getId).collect(Collectors.toList());
//            Map<Long, Integer> receiveQtyMap = receiveMapper.selectList(new QueryWrapper<Receive>().lambda().in(Receive::getOrderId, filingIds)
//                    .select(Receive::getOrderId, Receive::getReceiveQty)).stream().collect(Collectors.groupingBy(Receive::getOrderId, Collectors.summingInt(Receive::getReceiveQty)));
//            Map<Long, Integer> backQtyMap = backMapper.selectList(new QueryWrapper<Back>().lambda().in(Back::getOrderId, filingIds)
//                    .select(Back::getOrderId, Back::getBackQty)).stream().collect(Collectors.groupingBy(Back::getOrderId, Collectors.summingInt(Back::getBackQty)));
//            filings.forEach(item->{
//                Long filingId = item.getId();
//                String orderNo = item.getOrderNo();
//                String teamName = item.getZyTeam();
//                Integer rcvQty = ObjectUtil.isNull(receiveQtyMap.get(filingId))?0:receiveQtyMap.get(filingId);
//                Integer backQty = ObjectUtil.isNull(backQtyMap.get(filingId))?0:backQtyMap.get(filingId);
//                TeamStockDto teamStockDto = new TeamStockDto();
//                teamStockDto.setTeamName(teamName);
//                teamStockDto.setOrderNo(orderNo);
//                teamStockDto.setTotalRcvQty(rcvQty);
//                teamStockDto.setTotalBackQty(backQty);
//                teamStockDto.setTeamTotalQty(rcvQty-backQty);
//                teamStockDtos.add(teamStockDto);
//            });
//        }
//        return teamStockDtos;
//    }
}
