package cn.lttc.dpworkshopmanageserver.biz.team.controller;

import cn.lttc.dpworkshopmanageserver.biz.team.entity.Team;
import cn.lttc.dpworkshopmanageserver.biz.team.mapper.TeamMapper;
import cn.lttc.dpworkshopmanageserver.biz.team.param.TeamParam;
import cn.lttc.dpworkshopmanageserver.biz.team.service.ITeamService;
import cn.lttc.dpworkshopmanageserver.biz.team.service.impl.TeamServiceImpl;
import cn.lttc.dpworkshopmanageserver.biz.workshop.param.WorkshopParam;
import cn.lttc.dpworkshopmanageserver.biz.workshop.service.IWorkshopService;
import cn.lttc.dpworkshopmanageserver.core.pojo.response.ResponseData;
import cn.lttc.dpworkshopmanageserver.core.pojo.response.SuccessResponseData;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author soul
 * @version 1.0.0
 * @title FilingController
 * @description 建档
 * @create 2022/11/16 13:40
 **/
@RestController
@RequestMapping("/team")
public class TeamController {

    @Resource
    private ITeamService teamService;
    @PostMapping("/add")
    public ResponseData add(@RequestBody @Validated TeamParam teamParam){
        teamService.add(teamParam);
        return new SuccessResponseData();
    }
    @PostMapping("/edit")
    public ResponseData edit(@RequestBody @Validated TeamParam teamParam){
        teamService.edit(teamParam);
        return new SuccessResponseData();
    }
    @PostMapping("/delete")
    public ResponseData delete(@RequestBody @Validated List<TeamParam> teamParamList){
        teamService.delete(teamParamList);
        return new SuccessResponseData();
    }
    @GetMapping("/list")
    public ResponseData list(){
        return new SuccessResponseData(teamService.getTeamList());
    }

    @GetMapping("/list2/{workshopid}")
    public ResponseData list2(@PathVariable("workshopid") String workshopid){
//        return new SuccessResponseData(teamService.getTeamList());
//        QueryWrapper<Team> qw = new QueryWrapper<>();
//        qw.eq("workshop_id",Integer.parseInt(workshopid));
//        List<Team> teams = TeamMapper.selectList(qw);
//        return "你好，" + workshopid + " !";
//        System.out.println(workshopid.getClass().getName());
//        return workshopid.getClass().getName();
        List<Team> teamListByWorkshopId = teamService.getTeamListByWorkshopId(workshopid);
        return new SuccessResponseData(teamListByWorkshopId);
    }
//    @GetMapping("/listAvailable")
//    public ResponseData listAvailable(){
//        return new SuccessResponseData(workshopService.listAvailable());
//    }
//    @GetMapping("/getPlanOrderData")
//    public ResponseData getPlanOrderData(){
//        return new SuccessResponseData(workshopService.getPlanOrderData());
//    }
//    /**
//     * @description:  库存数量（<100）、当前时间-送活交接时间>两天
//     * @param: []
//     * @return: cn.lttc.dpworkshopmanageserver.core.pojo.response.ResponseData
//     * @author Soul
//     * @date: 2022/12/2 8:44
//     */
//    @GetMapping("/getFilterData")
//    public ResponseData getFilterData(){
//        return new SuccessResponseData(workshopService.getFilterData());
//    }
}
