package cn.lttc.dpworkshopmanageserver.biz.workshop.controller;

import cn.lttc.dpworkshopmanageserver.biz.filing.param.FilingParam;
import cn.lttc.dpworkshopmanageserver.biz.filing.service.IFilingService;
import cn.lttc.dpworkshopmanageserver.biz.workshop.param.WorkshopParam;
import cn.lttc.dpworkshopmanageserver.biz.workshop.service.IWorkshopService;
import cn.lttc.dpworkshopmanageserver.core.pojo.response.ResponseData;
import cn.lttc.dpworkshopmanageserver.core.pojo.response.SuccessResponseData;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author soul
 * @version 1.0.0
 * @title FilingController
 * @description 建档
 * @create 2022/11/16 13:40
 **/
@RestController
@RequestMapping("/workshop")
public class WorkshopController {

    @Resource
    private IWorkshopService workshopService;
    @PostMapping("/add")
    public ResponseData add(@RequestBody @Validated WorkshopParam workshopParam){
        workshopService.add(workshopParam);
        return new SuccessResponseData();
    }
    @PostMapping("/edit")
    public ResponseData edit(@RequestBody @Validated WorkshopParam workshopParam){
        workshopService.edit(workshopParam);
        return new SuccessResponseData();
    }
    @PostMapping("/delete")
    public ResponseData delete(@RequestBody @Validated List<WorkshopParam> WorkshopParamLst){
        workshopService.delete(WorkshopParamLst);
        return new SuccessResponseData();
    }
    @GetMapping("/list")
    public ResponseData list(){
        return new SuccessResponseData(workshopService.getWorkshopList());
    }
//    @GetMapping("/listAvailable")
//    public ResponseData listAvailable(){
//        return new SuccessResponseData(workshopService.listAvailable());
//    }
//    @GetMapping("/getPlanOrderData")
//    public ResponseData getPlanOrderData(){
//        return new SuccessResponseData(workshopService.getPlanOrderData());
//    }
//    /**
//     * @description:  库存数量（<100）、当前时间-送活交接时间>两天
//     * @param: []
//     * @return: cn.lttc.dpworkshopmanageserver.core.pojo.response.ResponseData
//     * @author Soul
//     * @date: 2022/12/2 8:44
//     */
//    @GetMapping("/getFilterData")
//    public ResponseData getFilterData(){
//        return new SuccessResponseData(workshopService.getFilterData());
//    }
}
