package cn.lttc.dpworkshopmanageserver.biz.workshop.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateField;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.lttc.dpworkshopmanageserver.biz.filing.dto.PlanOrderDto;
import cn.lttc.dpworkshopmanageserver.biz.filing.entity.Filing;
import cn.lttc.dpworkshopmanageserver.biz.filing.mapper.FilingMapper;
import cn.lttc.dpworkshopmanageserver.biz.filing.param.FilingParam;
import cn.lttc.dpworkshopmanageserver.biz.filing.service.IFilingService;
import cn.lttc.dpworkshopmanageserver.biz.receive.eneity.Receive;
import cn.lttc.dpworkshopmanageserver.biz.receive.mapper.ReceiveMapper;
import cn.lttc.dpworkshopmanageserver.biz.team.entity.Team;
import cn.lttc.dpworkshopmanageserver.biz.team.mapper.TeamMapper;
import cn.lttc.dpworkshopmanageserver.biz.workshop.entity.Workshop;
import cn.lttc.dpworkshopmanageserver.biz.workshop.mapper.WorkshopMapper;
import cn.lttc.dpworkshopmanageserver.biz.workshop.param.WorkshopParam;
import cn.lttc.dpworkshopmanageserver.biz.workshop.service.IWorkshopService;
import cn.lttc.dpworkshopmanageserver.core.context.login.LoginContextHolder;
import cn.lttc.dpworkshopmanageserver.core.exception.ServiceException;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author soul
 * @version 1.0.0
 * @title FilingServiceImpl
 * @description <TODO description class purpose>
 * @create 2022/11/16 14:02
 **/
@Service
public class WorkshopServiceImpl extends ServiceImpl<WorkshopMapper, Workshop> implements IWorkshopService {
    @Resource
    private WorkshopMapper workshopMapper;
    @Resource
    private TeamMapper teamMapper;

    @Override
    public void add(WorkshopParam workshopParam) {
        Workshop workshop = new Workshop();
        BeanUtil.copyProperties(workshopParam, workshop);
//        workshop.setStatus(1);
        workshop.setCreatedDate(DateUtil.date(new Date()));
        workshop.setCreatedUser(LoginContextHolder.me().getSysLoginUser().getId());
        this.save(workshop);
    }

    @Override
    public void edit(WorkshopParam workshopParam) {
        Workshop workshop = this.getById(workshopParam.getId());
        BeanUtil.copyProperties(workshopParam, workshop);
        this.updateById(workshop);
    }

    @Override
    public void delete(List<WorkshopParam> workshopParamLst) {
        if (CollectionUtil.isEmpty(workshopParamLst)) {
            return;
        } else {
            workshopParamLst.forEach(item -> {
                List<Team> teams = teamMapper.selectList(new QueryWrapper<Team>().lambda().eq(Team::getWorkshopId,
                        item.getId()));
                if (CollectionUtil.isNotEmpty(teams)) {
                    throw new ServiceException(500, "该车间使用中，不允许删除！");
                }
//                Workshop workshop = this.getById(item.getId());
//                workshop.setStatus(3);
                this.removeById(item.getId());
            });
        }
    }
//
//    @Override
//    public List<PlanOrderDto> getPlanOrderData() {
//        List<Filing> filings = filingMapper.selectList(new QueryWrapper<Filing>().lambda().eq(Filing::getStatus, 1).select(Filing::getOrderNo, Filing::getStockQty));
//        Map<String, Integer> collects = filings.stream().collect(Collectors.groupingBy(Filing::getOrderNo, Collectors.summingInt(Filing::getStockQty)));
//        List<PlanOrderDto> planOrderDtos = new ArrayList<>();
//        collects.forEach((orderNo, qty) -> {
//            PlanOrderDto planOrderDto = new PlanOrderDto();
//            planOrderDto.setOrderNo(orderNo);
//            planOrderDto.setQty(qty);
//            planOrderDtos.add(planOrderDto);
//        });
//        return planOrderDtos;
//    }
//
    @Override
    public List<Workshop> getWorkshopList() {
        return workshopMapper.selectList(null);
    }
//
//    @Override
//    public List<Filing> listAvailable() {
//        return workshopMapper.selectList(new QueryWrapper<Filing>().lambda().ne(Filing::getOrderStatus, 3).eq(Filing::getStatus, true));
//    }
//
//    @Override
//    public List<Filing> getFilterData() {
//        DateTime date = DateUtil.offset(DateUtil.date(new Date()), DateField.DAY_OF_MONTH, -2);
//        return workshopMapper.getFilterData(DateUtil.formatDate(date));
//    }
}
