package cn.lttc.dpworkshopmanageserver.core.auth.service;

import cn.lttc.dpworkshopmanageserver.core.login.pojo.SysLoginUser;
import cn.lttc.dpworkshopmanageserver.core.user.entity.SysUser;
import org.springframework.security.core.Authentication;

import javax.servlet.http.HttpServletRequest;

/**
 * @author soul
 * @version 1.0.0
 * @title IAuthService
 * @description <TODO description class purpose>
 * @create 2022/11/16 15:21
 **/
public interface IAuthService {
    String login(String account, String password);
    /**
     * 从request获取token
     *
     * @param request request
     * @return token
     * @author xuyuxiang
     * @date 2020/3/13 11:41
     */
    String getTokenFromRequest(HttpServletRequest request);

    /**
     * 根据token获取登录用户信息
     *
     * @param token token
     * @return 当前登陆的用户信息
     * @author xuyuxiang
     * @date 2020/3/13 11:59
     */
    SysLoginUser getLoginUserByToken(String token);

    /**
     * 设置SpringSecurityContext上下文，方便获取用户
     *
     * @param sysLoginUser 当前登录用户信息
     * @author xuyuxiang
     * @date 2020/3/19 19:59
     */
    void setSpringSecurityContextAuthentication(SysLoginUser sysLoginUser);

    Authentication getAuthentication();

    SysLoginUser genSysLoginUser(SysUser sysUser);

    void logout();
}
