package cn.lttc.dpworkshopmanageserver.core.login.pojo;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.lang.Dict;
import cn.hutool.core.util.ObjectUtil;
import cn.lttc.dpworkshopmanageserver.core.consts.CommonConstant;
import cn.lttc.dpworkshopmanageserver.core.pojo.login.SnowyAuthority;
import lombok.Data;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * @author soul
 * @version 1.0.0
 * @title SysLoginUser
 * @description <TODO description class purpose>
 * @create 2022/11/17 8:52
 **/
@Data
public class SysLoginUser implements UserDetails, Serializable {
    private Long id;
    private String account;
    private String name;
    private Boolean adminType;
    /**
     * 角色信息
     */
    private List<Dict> roles;

    @Override
    public Collection<? extends GrantedAuthority> getAuthorities() {
        ArrayList<SnowyAuthority> grantedAuthorities = CollectionUtil.newArrayList();
        if (ObjectUtil.isNotEmpty(roles)) {
            roles.forEach(dict -> {
                String roleName = dict.getStr(CommonConstant.NAME);
                SnowyAuthority snowyAuthority = new SnowyAuthority(roleName);
                grantedAuthorities.add(snowyAuthority);
            });
        }
        return grantedAuthorities;
    }

    @Override
    public String getPassword() {
        return null;
    }

    @Override
    public String getUsername() {
        return this.account;
    }

    @Override
    public boolean isAccountNonExpired() {
        //能生成loginUser就是jwt解析成功，没锁定
        return true;
    }

    @Override
    public boolean isAccountNonLocked() {
        //能生成loginUser就是jwt解析成功，没锁定
        return true;
    }

    @Override
    public boolean isCredentialsNonExpired() {
        //能生成loginUser就是jwt解析成功，没锁定
        return true;
    }

    @Override
    public boolean isEnabled() {
        //能生成loginUser就是jwt解析成功，没锁定
        return true;
    }
}
