package cn.lttc.dpworkshopmanageserver.core.user.controller;

import cn.lttc.dpworkshopmanageserver.core.context.login.LoginContextHolder;
import cn.lttc.dpworkshopmanageserver.core.pojo.response.ResponseData;
import cn.lttc.dpworkshopmanageserver.core.pojo.response.SuccessResponseData;
import cn.lttc.dpworkshopmanageserver.core.user.param.ModifyPasswordParam;
import cn.lttc.dpworkshopmanageserver.core.user.param.SysUserParam;
import cn.lttc.dpworkshopmanageserver.core.user.service.ISysUserService;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author soul
 * @version 1.0.0
 * @title UserController
 * @description <TODO description class purpose>
 * @create 2022/11/16 14:29
 **/
@RestController
@RequestMapping("/sys/user")
public class UserController {
    @Resource
    private ISysUserService sysUserService;

    @PostMapping("/add")
    public ResponseData add(@RequestBody @Validated SysUserParam sysUserParam){
        sysUserService.add(sysUserParam);
        return new SuccessResponseData();
    }

    @PostMapping("/edit")
    public ResponseData edit(@RequestBody @Validated SysUserParam sysUserParam){
        sysUserService.edit(sysUserParam);
        return new SuccessResponseData();
    }
    @PostMapping("/deleteUser")
    public ResponseData deleteUser(@RequestBody @Validated List<SysUserParam> sysUserParamLst){
        sysUserService.delete(sysUserParamLst);
        return new SuccessResponseData();
    }

    @GetMapping("/getLoginUser")
    public ResponseData getLoginUser() {
        return new SuccessResponseData(LoginContextHolder.me().getSysLoginUserUpToDate());
    }
    @GetMapping("/list")
    public ResponseData list() {
        return new SuccessResponseData(sysUserService.listUser());
    }

    @PostMapping("/profile/modifyPassword")
    public ResponseData modifyPassword(@RequestBody @Validated ModifyPasswordParam param){
        sysUserService.modifyPassword(param);
        return new SuccessResponseData();
    }
    @GetMapping("/checkUserAccount/{account}")
    public ResponseData checkUserAccount(@PathVariable String account){
        return new SuccessResponseData(sysUserService.checkUserAccount(account));
    }
}
